unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Contnrs, ExtCtrls;

type
  TStkObj = class(TControl)
  private
    fquanBar: TProgressBar;
    function getLeft: Integer;
    function getTop: Integer;
    procedure setLeft(const Value: Integer);
    procedure setTop(const Value: Integer);
  public
    property Top: Integer read getTop write setTop;
    property Left: Integer read getLeft write setLeft;

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;
  TForm1 = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    ftmpList: TObjectList;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TStkObj }

constructor TStkObj.Create(AOwner: TComponent);
begin
  inherited;
  fquanBar := TProgressBar.Create(AOwner);
  fquanBar.Parent := TWinControl(AOwner);
  fquanBar.Max := 100;
  fquanBar.Position := 70;
  fquanBar.Width := 200;
  Top := 10;
  Left := 10;
end;

destructor TStkObj.Destroy;
begin
  fquanBar.Free;
  inherited;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  StkObj: TStkObj;
begin
  ftmpList.Clear;

  StkObj := TStkObj.Create(Self);
  StkObj.Top := 60;
  ftmpList.Add(StkObj);

  StkObj := TStkObj.Create(Self);
  StkObj.Top := 100;
  ftmpList.Add(StkObj); 
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ftmpList := TObjectList.Create;  
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ftmpList.Free;
end;

function TStkObj.getLeft: Integer;
begin
  Result := fquanBar.Left;
end;

function TStkObj.getTop: Integer;
begin
  Result := fquanBar.Top;
end;

procedure TStkObj.setLeft(const Value: Integer);
begin
  fquanBar.Left := Value;
end;

procedure TStkObj.setTop(const Value: Integer);
begin
  fquanBar.Top := Value;
end;

end.
 